diff -ruN uppsrc/Core/String.h uppsrc/Core/String.h
--- uppsrc/Core/String.h	2012-11-29 23:34:05 +0400
+++ uppsrc/Core/String.h	2013-05-26 07:38:50 +0400
@@ -337,6 +337,15 @@
 	String& operator=(StringBuffer& b)                     { *this = String(b); return *this; }
 	String& operator<<=(const String& s)                   { if(this != &s) { String0::Free(); String0::Set(s, s.GetCount()); } return *this; }
 
+	String& operator<<(const char *x);
+	String& operator<<(char *x);
+	String& operator<<(const String& x);
+	String& operator<<(char x);
+	String& operator<<(const void *x);
+	String& operator<<(void *x);
+	template <class T>
+	String& operator<<(const T& x);
+
 	void   Shrink()                                        { *this = String(Begin(), GetLength()); }
 	int    GetCharCount() const;
 
@@ -430,68 +439,68 @@
 	return FormatPtr(x);
 }
 
-force_inline String& operator<<(String& s, const char *x)
+force_inline String& String::operator<<(const char *x)
 {
-	s.Cat(x, strlen__(x));
-	return s;
+	Cat(x, strlen__(x));
+	return *this;
 }
 
-force_inline String& operator<<(String& s, char *x)
+force_inline String& String::operator<<(char *x)
 {
-	s.Cat(x);
-	return s;
+	Cat(x);
+	return *this;
 }
 
-inline String& operator<<(String& s, const String &x)
+inline String& String::operator<<(const String& x)
 {
-	s.Cat(x);
-	return s;
+	Cat(x);
+	return *this;
 }
 
-inline String& operator<<(String& s, char x)
+inline String& String::operator<<(char x)
 {
-	s.Cat((int) x);
-	return s;
+	Cat((int) x);
+	return *this;
 }
 
-inline String& operator<<(String& s, const void *x)
+inline String& String::operator<<(const void *x)
 {
-	s << FormatPtr(x);
-	return s;
+	*this << FormatPtr(x);
+	return *this;
 }
 
-inline String& operator<<(String& s, void *x)
+inline String& String::operator<<(void *x)
 {
-	s << FormatPtr(x);
-	return s;
+	*this << FormatPtr(x);
+	return *this;
 }
 
 template <class T>
-inline String& operator<<(String& s, const T& x)
+inline String& String::operator<<(const T& x)
 {
-	s.Cat(AsString(x));
-	return s;
+	Cat(AsString(x));
+	return *this;
 }
 
 template<>
-inline String& operator<<(String& s, const char * const &x)
+inline String& String::operator<<(const char * const &x)
 {
-	s.Cat(x);
-	return s;
+	Cat(x);
+	return *this;
 }
-
+/*
 template<>
-inline String& operator<<(String& s, const String &x)
+inline String& String::operator<<(const String& x)
 {
-	s.Cat(x);
-	return s;
+	Cat(x);
+	return *this;
 }
-
+*/
 template<>
-inline String& operator<<(String& s, const char& x)
+inline String& String::operator<<(const char& x)
 {
-	s.Cat(x);
-	return s;
+	Cat(x);
+	return *this;
 }
 
 template<>
